#include<bits/stdc++.h>
using namespace std;
int main ()
{
    int n;
    int o,a,b,ab,x,k=0,vakcine=0,doze=0,p;
    cin>>n;
    vector<int> br_vakcina;
    int matrica[n][4];
    cin>>o>>a>>b>>ab;
    string s0;
    vector<string> s;
    for(int i=0; i<n; i++)
    {
        cin>>s0;
        cin>>p;
        br_vakcina.push_back(p);
        s.push_back (s0);
        vakcine+=br_vakcina[i];
    }
    doze=o+a+b+ab;
    if(vakcine>doze)
    {
        cout<<"nemoguce";
        return 0;
    }
    for(int i=0; i<n; i++)
    {
        if(s[i]=="O")
        {
            if(o<br_vakcina[i])
                k++;
            else
            {
                matrica[i][0]=br_vakcina[i];
                matrica[i][1]=0;
                matrica[i][2]=0;
                matrica[i][3]=0;
                o-=br_vakcina[i];
            }
        }
    }
    for(int i=0; i<n; i++)
    {
        if(s[i]=="A")
        {
            if(br_vakcina[i]>(a+o))
                k++;
            else
            {
                if(br_vakcina[i]<=a)
                {
                    matrica[i][0]=0;
                    matrica[i][1]=br_vakcina[i];
                    matrica[i][2]=0;
                    matrica[i][3]=0;
                    a-=br_vakcina[i];
                    br_vakcina[i]=0;
                }
                else
                {
                    matrica[i][0]=br_vakcina[i]-a;
                    matrica[i][1]=a;
                    matrica[i][2]=0;
                    matrica[i][3]=0;
                    o=o+(a-br_vakcina[i]);
                    br_vakcina[i]=0;
                    a=0;
                }
            }
        }
    }
    for(int i=0; i<n; i++)
    {
        if(s[i]=="B")
        {
            if(br_vakcina[i]>(b+o))
                k++;
            else
            {
                if(br_vakcina[i]<=b)
                {
                    matrica[i][0]=0;
                    matrica[i][1]=0;
                    matrica[i][2]=br_vakcina[i];
                    matrica[i][3]=0;
                    b-=br_vakcina[i];
                    br_vakcina[i]=0;
                }
                else
                {
                    matrica[i][0]=br_vakcina[i]-b;
                    matrica[i][1]=0;
                    matrica[i][2]=b;
                    matrica[i][3]=0;

                    o=o+(b-br_vakcina[i]);
                    br_vakcina[i]=0;
                    b=0;
                }
            }
        }
    }
    for(int i=0; i<n; i++)
    {
        if(s[i]=="AB")
        {
            if(br_vakcina[i]>(ab+o+a+b))
                k++;
            else
            {
                if(br_vakcina[i]<ab)
                {
                    matrica[i][0]=0;
                    matrica[i][1]=0;
                    matrica[i][2]=0;
                    matrica[i][3]=br_vakcina[i];
                    ab-=br_vakcina[i];
                    br_vakcina[i]=0;
                }
                else
                {
                    if(o>=br_vakcina[i])
                    {
                        matrica[i][0]=br_vakcina[i];
                        matrica[i][1]=0;
                        matrica[i][2]=0;
                        matrica[i][3]=0;
                        br_vakcina[i]=0;
                        o-=br_vakcina[i];
                    }
                    else
                    {
                        matrica[i][0]=o;
                        br_vakcina[i]-=o;
                        o=0;
                        if(a>=br_vakcina[i])
                        {
                            matrica[i][1]=br_vakcina[i];
                            a-=br_vakcina[i];
                            br_vakcina[i]=0;
                        }
                        else
                        {
                            matrica[i][1]=a;
                            br_vakcina[i]-=a;
                            a=0;
                            if(b>=br_vakcina[i])
                            {
                                matrica[i][2]=br_vakcina[i];
                                b-=br_vakcina[i];
                                br_vakcina[i]=0;
                            }
                            else
                            {
                                matrica[i][2]=b;
                                br_vakcina[i]-=b;
                                b=0;
                                if(ab>=br_vakcina[i])
                                {
                                    matrica[i][3]=br_vakcina[i];
                                    ab-=br_vakcina[i];
                                    br_vakcina[i]=0;
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    if(k!=0)
        cout<<"nemoguce";
    else
    {
        cout<<"moguce"<<endl;
        for(int i=0; i<n; i++)
        {
            for(int j=0; j<4; j++)
                cout<<matrica[i][j]<<' ';
            cout<<endl;
        }
    }
    s.clear();
    br_vakcina.clear();
    return 0;
}